PAGE 66,132
TITLE 3xp1-4.asm

COMMENT *
*

;-----------------------------------------------------------------
; Interfaccia con l'esterno
.SALL                          ; soppressione espansione macro nel testo
IF1                            ; l'inclusione delle macro avviene
INCLUDE DOSINT.MCR             ; nel primo passo dell'assemblaggio
ENDIF


keybuff macro buffer            ; lettura di una stringa da tastiera in un buffer di memoria
        push dx                 ; (N.B. la stringa termina con ENTER; il primo byte del buffer
        push bx                 ; contiene il max numero di caratteri da leggere, ed il secondo
        push ax                 ; byte contiene il numero totale di caratteri letti,
        mov dx,offset buffer    ; escluso CR (=ENTER); i caratteri letti (l'ultimo e' CR)
        mov ah,0ah              ; cominciano dal terzo byte
        int 21h
        mov bl,buffer[1]        ; (questa istruzione scrive in strlen)
        add bl,2                ; (i primi due byte del buffer)
        and bx,00ffh
        mov buffer[bx],'$'      ; Sovrascritto a CR, ed usato per motivi di display
                                ; non viene conteggiato in strlen=buffer[1]
        pop ax
        pop bx
        pop dx
        endm


;-----------------------------------------------------------------
; Definizione costanti
CR EQU 13                      ; carriage return
LF EQU 10                      ; line feed

;-----------------------------------------------------------------
;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK')  ; lo stack e' riempito con la stringa 'stack'
                               ; per identificarlo meglio in fase di debug
TOS   LABEL WORD               ; identifica il top of stack
STACK ENDS                     ;

;-----------------------------------------------------------------
;
DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati

N_iter equ 100
maxN equ 8
stringa_num db maxN dup ('n'),'$'
crlf db CR,LF,'$'

max_strlen equ 6
buffer_in label byte
maxlen_in db max_strlen
strlen_in db ?
string_in db max_strlen dup ('b'),'$'

weight dw 1
accum dw 0

DATA ENDS

;-----------------------------------------------------------------
;
CSEG SEGMENT PUBLIC 'CODE'

MAIN PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK,ES:NOTHING;

        MOV AX,DATA           ; necessari 2 trasferimenti per assegnare a DS
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito

        ; algoritmo 3x+1
       
        mov cx,N_iter
        keybuff buffer_in
        display crlf

        push cx       
        mov bh,0
        mov bl,strlen_in
        mov cx,bx

        ; conversione della stringa digitata in binario (AX)
        mov weight,1
        mov accum,0
convloop:
        mov al,string_in[bx-1]
        and ax,000Fh
        mul weight   ; dx|ax := ax * weight
        add accum,ax        
        mov ax,10
        mul weight
        mov weight,ax
        dec bx
        loop convloop

        mov ax,accum
        pop cx
itera:        

calcolax:
            test ax,1
            jz pari
dispari:                  ; ax:=3*ax+1
            cmp ax,1
            je fine
            mov bx,ax    
            add bx,ax
            add ax,bx
            inc ax
            jmp visualizzax
pari:                     ; ax:=ax/2
            shr ax,1

visualizzax:
            push ax
            mov ax,offset stringa_num
            push ax
            mov ax,maxN
            push ax

            call near ptr bin2ascii

            pop bx
            mov stringa_num[bx],'$'
            add sp,2
            pop ax

            display stringa_num
            display crlf


        loop itera

fine:


        mov ah,4ch
        int 21h

MAIN ENDP


; routine di conversione di un numero a 16 bit (il cui valore e' posto nello stack)
; in una stringa di N caratteri, il cui indirizzo e' anch'esso inserito nello stack
; prima della chiamata. Il valore di ritorno N rimpiazza il valore immesso nello stack
; dal chiamante, che indica la dimensione massima della stringa, maxN
bin2ascii proc near
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        pushf

        mov bp,sp
        add bp,16                          ; rimuove l'effetto dei push qui sopra
        mov ax,SS:[bp+6]                   ; numero da convertire (e' sepolto sotto 3 words)

        mov bx,10
        mov cx,0
        mov dx,0
again:  div bx                             ; in DX il resto, in AX il quoziente di [DX:AX]/[BX]
        or dx,0030h
        push dx
        inc cx
        cmp ax,0
        je save_result
        xor dx,dx
        jmp again
save_result:
        mov di,0
        mov bx,[bp+4]                      ; offset della stringa destinazione
cycle:  pop dx
        mov [bx][di],dl
        inc di
        loop cycle
        mov [bp+2],di                      ; numero di caratteri nella stringa destinazione

        popf
        pop bp
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax

        ret

bin2ascii endp


CSEG ENDS

END MAIN                     ; il programma comincia all'indirizzo di MAIN
