TITLE accuproc.asm: per esercitazione Calcolatori 30/11/2020

comment *
	Chiamante e subroutine per l'accumulazione in assembler 8086.
	Serve a mostrare l'uso dello stack nella programmazione assembler.

		data creazione: 29 novembre 2020
		ultima revisione: 30 novembre 2020
*


;-----------------------------------------------------------------
; Definizione costanti
CR EQU 13                      ; carriage return
LF EQU 10                      ; line feed
DOLLAR EQU '$'


;-----------------------------------------------------------------
;    M  A  C  R  O
;-----------------------------------------------------------------

display macro xxxx           ; N.B. ogni stringa deve terminare con '$' 
        push dx
	    push ax
	    mov dx,offset xxxx
	    mov ah,9
	    int 21h
	    pop ax
        pop dx
endm


;-----------------------------------------------------------------
;
PILA SEGMENT STACK 'STACK'     ; definizione del segmento di stack
      DB      64 DUP('STACK')  ; lo stack e' riempito con la stringa 'stack'
                               ; per identificarlo meglio in fase di debug
PILA ENDS                      

;-----------------------------------------------------------------
;
DATI SEGMENT PUBLIC 'DATA'    ; definizione del segmento dati

CRLF                 db CR,LF,DOLLAR
COMMA                db ',',DOLLAR

messaggio_v          db "vettore da accumulare:  ",DOLLAR
messaggio_n          db "numero di elementi (n):  ",DOLLAR
messaggio_s          db "risultato (lettura per bytes):  ",DOLLAR
     
vec_12_w             label word
vec_2                label byte
vec_1                db 17,35,88,13,56,39,57,131
n_1                  equ $-vec_1 ; = 8 ($ e' chiamato "location counter")
                     db 223,107,67
n_2                  equ $-vec_2 ; = 11

somma_1              dw ? ; = 436
somma_2              dw ? ; = 833
somma_1_w            dw ? ; = 436
somma_2_w            dw ? ; = 833

; per conversione del risultato in ASCII e stampa a video
max_strlen equ 16
stringa_ax           db max_strlen dup (?),' $'
alfabeto_numerazione db "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

DATI ENDS  
 
;=================================================================

CSEG1 SEGMENT PUBLIC 'CODE'

MAIN proc far
        ASSUME CS:CSEG1,DS:DATI,SS:PILA,ES:NOTHING;

        MOV AX,SEG DATI
        MOV DS,AX

        ; ****************** VETTORE vec_1 ********************
        mov ax,n_1
		push ax
		mov ax,offset vec_1
		push ax
		
		call near ptr stampaccumula
		
		pop ax
		add sp,2 ; aggiustamento dello SP al valore che aveva prima della chiamata
		
		; salvataggio e stampa del risultato
		mov somma_1,ax			
		display crlf
        display messaggio_s	; risultato	
	    call near ptr display_ax	
		display crlf			
		
		; ****************** VETTORE vec_2 ********************
		mov ax,n_2
		push ax
		mov ax,offset vec_2
		push ax
		
		call near ptr stampaccumula
		
		pop ax
		add sp,2 ; aggiustamento dello SP al valore che aveva prima della chiamata
		
		; salvataggio e stampa del risultato
		mov somma_2,ax			
		display crlf
        display messaggio_s	; risultato	
	    call near ptr display_ax	
		display crlf			
		

	exit: 
        MOV AH,4CH                 ; ritorno al DOS
        INT 21H

main endp
;***************************************************************


		
;****** DISPLAY e ACCUMULAZIONE del VETTORE passato dal chiamante *****
STAMPACCUMULA proc NEAR
		
		; salvataggio nello stack dei registri che saranno utilizzati 
		push ax
		push cx
		push dx
		push si
		push bp
		
	    ; prelievo dati dallo stack dei dati da elaborare
		mov bp,sp           ; bp e' usato per "scavalcare" i registri salvati e l'indirizzo di ritorno
		mov si,SS:[bp+12]   ; bp+12 punta all'ultimo parametro scritto(indirizzo del vettore)
		mov cx,[bp+14]      ; bp+14 punta al primo parametro scritto(numero elementi del vettore)
				
		; stampa a video dati
		push cx ; salvo in stack indirizzo vettore e numero elementi da usare dopo
		push si
		display crlf
        display messaggio_v	; elementi del vettore	
        xor dh,dh		
		display_loop:
		    mov dl,[si]
		    mov ax,dx
            call near ptr display_ax
			dec cx
			jz loop_end
            display comma			
			inc si			
			jmp display_loop
	    loop_end:
		pop si  ; ripristino registri salvati (indirizzo vettore e numero elementi)
		pop cx
		display crlf
        display messaggio_n	; dimensione del vettore		
		mov ax,cx
        call near ptr display_ax
				
		; accumulazione della somma degli elementi in AX e suo salvataggio nello stack
		xor ax,ax
		xor dh,dh ; superflua (messa gia' prima), ma si rimette qui per chiarezza 
				   
		ciclo_accum:
			mov dl,[si]
			add ax,dx
			inc si
			dec cx
			jnz ciclo_accum
			
		mov [bp+12],ax ; salvataggio del risultato nello stack, al posto dell'indirizzo del vettore
			
		; ripristino dei registri e rientro al chiamante (notare l'ordine inverso rispetto al push)
        pop bp		
        pop si
        pop dx
        pop cx
        pop ax

        RET		

stampaccumula endp	
;***************************************************************				   

; routine di conversione di un numero a 16 bit (il cui valore e' posto nello stack)
; nell'equivalente in una base prefissata, espresso in ASCII e posto
; in una stringa di N caratteri, il cui indirizzo e' anch'esso inserito nello stack
; prima della chiamata. Il valore di ritorno N rimpiazza il valore immesso nello stack
; dal chiamante, che indica la base in cui convertire il numero
;
bin2bascii proc near
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        pushf

        mov bp,sp
        add bp,16                          ; rimuove l'effetto dei push qui sopra
        mov ax,SS:[bp+6]                   ; numero da convertire (e' sepolto sotto 3 words)

        mov bx,[bp+2]
        mov cx,0
again:  xor dx,dx
        div bx                             ; in DX il resto, in AX il quoziente di [DX:AX]/[BX]
                                           ; N.B. con or dx,0030h si renderebbe ASCII il contenuto di dx
        mov si,dx
        mov dl,alfabeto_numerazione[si]    ; si prende il simbolo di numerazione dall'array apposito
        xor dh,dh
        push dx
        inc cx
        cmp ax,0
        je save_result
        jmp again
save_result:
        mov di,0
        mov bx,[bp+4]                      ; offset della stringa destinazione
cycle:  pop dx
        mov [bx][di],dl
        inc di
        loop cycle
        mov [bp+2],di                      ; numero di caratteri nella stringa destinazione

        popf
        pop bp
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax

        ret

bin2bascii endp

; routine di conversione e stampa a video formattata  
; di un numero intero non negativo posto nel registro AX
;
display_ax proc near 
        push ax
        push bx

        push ax
        mov ax,offset stringa_ax
        push ax
        mov ax,10
        push ax
        call near ptr bin2bascii
        pop bx                       ; in bx il numero di caratteri della stringa
        add sp,4                                     

        mov stringa_ax[bx],'$'        ; $ per poter stampare
        display stringa_ax

        pop bx
        pop ax
        ret

display_ax endp



cseg1 ends

END MAIN                     ; il programma comincia all'indirizzo di MAIN

                         
