TITLE mult2016.asm: per esercitazione Calcolatori 6/12/2016

comment *
	Tre piccoli programmi per la moltiplicazione intera in assembler 8086.

		data creazione: 5 dicembre 2016
		ultima revisione: 30 novembre 2020
*


;-----------------------------------------------------------------
; Definizione costanti
CR EQU 13                      ; carriage return
LF EQU 10                      ; line feed
DOLLAR EQU '$'


;-----------------------------------------------------------------
;    M  A  C  R  O
;-----------------------------------------------------------------

display macro xxxx           ; N.B. ogni stringa deve terminare con '$' 
        push dx
	    push ax
	    mov dx,offset xxxx
	    mov ah,9
	    int 21h
	    pop ax
        pop dx
endm


;-----------------------------------------------------------------
;
PILA SEGMENT STACK 'STACK'     ; definizione del segmento di stack
      DB      64 DUP('STACK')  ; lo stack e' riempito con la stringa 'stack'
                               ; per identificarlo meglio in fase di debug
PILA ENDS                      

;-----------------------------------------------------------------
;
DATI SEGMENT PUBLIC 'DATA'    ; definizione del segmento dati

CRLF                 db CR,LF,DOLLAR
SEP                  db ':',DOLLAR
TIMES                db ' x ',DOLLAR
EQUAL                db ' = ',DOLLAR

messaggio1           db "uso della istruzione MUL <op>:  ",DOLLAR
messaggio2           db "uso di SOMMATORE a 2n bit:  ",DOLLAR
messaggio3           db "uso di SOMMATORE a n bit:  ",DOLLAR

moltiplicando        db 123
moltiplicatore       db 204
prodotto             dw ?

; per conversione del risultato in ASCII e stampa a video
max_strlen equ 16
stringa_ax           db max_strlen dup (?),' $'
alfabeto_numerazione db "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

DATI ENDS  
 
;=================================================================

CSEG1 SEGMENT PUBLIC 'CODE'

MAIN proc far
        ASSUME CS:CSEG1,DS:DATI,SS:PILA,ES:NOTHING;

        MOV AX,SEG DATI
        MOV DS,AX

        ;****** 1. USO DELL'ISTRUZIONE 8086 'MUL' *****

		mov dl, moltiplicando
        mov bl, moltiplicatore

        ; stampa a video operandi
		display crlf
        display messaggio1
        xor dh,dh
		mov ax,dx
        call near ptr display_ax
        display times
        xor bh,bh
		mov ax,bx
		call near ptr display_ax
        display equal
                
        mov al,dl
        mul bl ; mul operando <===> ax <--- al*operando

        mov prodotto,ax

        ; stampa a video risultato
		call near ptr display_ax              
		display crlf



        ;****** 2. MULTIPLICAZIONE con SOMMATORE A 2n BIT *****
		; (cfr. lezioni reti sequenziali 2020-2021)

		mov dl,moltiplicando
        mov bl,moltiplicatore
                
        ; stampa a video operandi
		display crlf
        display messaggio2
        xor dh,dh
		mov ax,dx
        call near ptr display_ax
        display times
        xor bh,bh
		mov ax,bx
		call near ptr display_ax
        display equal
     
        xor ax,ax
        mov cx,8
        muloop2: 	
				        test bl,1
                        jz update2
        accumulate2:	add ax,dx
        update2:        shr bl,1
                        shl dx,1
                        sub cx,1
                        ;cmp cx,0
                        jnz muloop2

        mov prodotto,ax

        ; stampa a video risultato
		call near ptr display_ax              
		display crlf                


        ;****** 3. MULTIPLICAZIONE con SOMMATORE A n BIT *****
		; (cfr. lezioni reti sequenziali 2019-2020)		

		mov dl,moltiplicando
        mov bl,moltiplicatore

        ; stampa a video operandi
		display crlf
        display messaggio3
        xor dh,dh
		mov ax,dx
        call near ptr display_ax
        display times
        xor bh,bh
		mov ax,bx
		call near ptr display_ax
        display equal
      
        xor ah,ah
        mov al,bl
        mov cx,8
        muloop3: 	
				      xor bh,bh
                      test al,1
                      jz update3
        accumulate3:  add ah,dl
                      jnc update3
                      mov bh,80h 	; N.B. 80h=10000000b
		update3:        
    				  shr al,1
                      test ah,1
                      jz skip3
                      or al,80h                
        skip3:        shr ah,1
                      or ah,bh                      		
        check3:       sub cx,1
                      cmp cx,0
                      jnz muloop3

        mov prodotto,ax

        ; stampa a video risultato
		call near ptr display_ax              
		display crlf    

        ;***************************************************************


	exit: 
        MOV AH,4CH                 ; ritorno al DOS
        INT 21H

main endp



; routine di conversione di un numero a 16 bit (il cui valore e' posto nello stack)
; nell'equivalente in una base prefissata, espresso in ASCII e posto
; in una stringa di N caratteri, il cui indirizzo e' anch'esso inserito nello stack
; prima della chiamata. Il valore di ritorno N rimpiazza il valore immesso nello stack
; dal chiamante, che indica la base in cui convertire il numero
;
bin2bascii proc near
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        pushf

        mov bp,sp
        add bp,16                          ; rimuove l'effetto dei push qui sopra
        mov ax,SS:[bp+6]                   ; numero da convertire (e' sepolto sotto 3 words)

        mov bx,[bp+2]
        mov cx,0
again:  xor dx,dx
        div bx                             ; in DX il resto, in AX il quoziente di [DX:AX]/[BX]
                                           ; N.B. con or dx,0030h si renderebbe ASCII il contenuto di dx
        mov si,dx
        mov dl,alfabeto_numerazione[si]    ; si prende il simbolo di numerazione dall'array apposito
        xor dh,dh
        push dx
        inc cx
        cmp ax,0
        je save_result
        jmp again
save_result:
        mov di,0
        mov bx,[bp+4]                      ; offset della stringa destinazione
cycle:  pop dx
        mov [bx][di],dl
        inc di
        loop cycle
        mov [bp+2],di                      ; numero di caratteri nella stringa destinazione

        popf
        pop bp
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax

        ret

bin2bascii endp

; routine di conversione e stampa a video formattata  
; di un numero intero non negativo posto nel registro AX
;
display_ax proc near 
        push ax
        push bx

        push ax
        mov ax,offset stringa_ax
        push ax
        mov ax,10
        push ax
        call near ptr bin2bascii
        pop bx                       ; in bx il numero di caratteri della stringa
        add sp,4                                     

        mov stringa_ax[bx],'$'        ; $ per poter stampare
        display stringa_ax

        pop bx
        pop ax
        ret

display_ax endp



cseg1 ends

END MAIN                     ; il programma comincia all'indirizzo di MAIN

                         
