TITLE pfrac: per compito 15/01/2020

comment *
versione con un output arricchito rispetto a quello richiesto
dal compito: si stampano a video
sia lo sviluppo binario di p/q, che le parti di antiperiodo
e di periodo. Si stampano inoltre le lunghezze h e k di
antieriodo e periodo, rispettivamente.
*

;-----------------------------------------------------------------
; Definizione costanti
CR EQU 13                      ; carriage return
LF EQU 10                      ; line feed
DOLLAR EQU '$'


;-----------------------------------------------------------------
;    M  A  C  R  O
;-----------------------------------------------------------------

display macro xxxx                 ; N.B. ogni stringa deve terminare con '$' 
    push dx
	push ax
	mov dx,offset xxxx
	mov ah,9
	int 21h
	pop ax
    pop dx
endm



;-----------------------------------------------------------------
;
PILA SEGMENT STACK 'STACK'     ; definizione del segmento di stack
      DB      16 DUP('STACK')  ; lo stack e' riempito con la stringa 'stack'
                               ; per identificarlo meglio in fase di debug
PILA ENDS                      

;-----------------------------------------------------------------
;
DATI SEGMENT PUBLIC 'DATA'         ; definizione del segmento dati

p equ 17;35 ; possono essere sia byte che word
q equ 28;88

rtsequence  db q dup (?) ; vettore che si popolerà degli rt toccati (valori 8 bit)
visited   db q dup (0) ; vettore (di indici) che tiene traccia di tutti gli rt toccati
seqbits  db q dup (?) ; sequenza di bit dopo la virgola (=antiperiodo seguito da periodo)
alen dw ? ; lunghezza antiperiodo (da calcolare)
plen dw ? ; lunghezza periodo (da calcolare)



max_strlen equ 16
stringa_ax           db max_strlen dup (?),' $'
alfabeto_numerazione db "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

CRLF                 db CR,LF,DOLLAR
EQUAL                db "= ",DOLLAR
atext                db "(antiperiod) ",DOLLAR
ptext                db "(period)",DOLLAR
dots                 db "...",DOLLAR
PLUS                 db "+ ",DOLLAR
openbracket          db "[ ",DOLLAR
closedbracket        db "]",DOLLAR

pequ                 db "p=",DOLLAR
qequ                 db "q=",DOLLAR
poverqequ0comma      db "p/q = 0 , ",DOLLAR
cyclengthequ         db "cycle length = ",DOLLAR

DATI ENDS  
 

;=================================================================

CSEG SEGMENT PUBLIC 'CODE'

MAIN proc far
        ASSUME CS:CSEG,DS:DATI,SS:PILA,ES:NOTHING;

        MOV AX,DATI
        MOV DS,AX
		
		display crlf
		display pequ
		mov ax,p
		call near ptr display_ax
		display crlf
		display qequ
		mov ax,q
		call near ptr display_ax
        display crlf
		display poverqequ0comma		
		
		mov si,1 ; tiene traccia del numero rt già visitati: alla fine conterrà alen+plen		
		mov bx,p ; bx <-> rt (bx usato per poter puntare al vettore di memoria visited)
		mov visited[bx],1 		
		mov rtsequence[si-1],bl ; il vettore e' di bytes

 
 flippercycle:
		shl bx,1 ; moltiplico per 2
		cmp bx,q
		jge reduce
		mov ax,0 
		mov seqbits[si-1],al		
		jmp stampavvideo
reduce:
        sub bx,q
		mov ax,1 ; ogni bit sarà visualizzato con display_ax
		mov seqbits[si-1],al
stampavvideo:
        call near ptr display_ax
controlla:
        mov dl,visited[bx]
		cmp dl,0
		jne termina
aggiorna:
        inc si
		mov ax,si
		mov visited[bx],al 		
		mov rtsequence[si-1],bl 	
		jmp flippercycle

termina:                        ; se siamo qui allora si=alen+plen e dl=alen+1
                                ; dunque alen=0:dl-1, plen=si-alen 
        display dots
		display crlf
		display cyclengthequ
        mov ax,si
		call near ptr display_ax
        display EQUAL
        xor dh,dh
		mov ax,dx
        sub ax,1
		call near ptr display_ax
		mov alen,ax
		display atext
		display PLUS
		sub si,ax     ; qui ax contiene alen
        mov ax,si	  ; qui ax contiene plen
		call near ptr display_ax
        mov plen,ax
        display ptext		
        display crlf

		mov si,0
		xor ah,ah
		display openbracket
	    mov cx,alen	
		cmp cx,0
		je close_ap
output_antiperiod:
        mov al,seqbits[si]
		call near ptr display_ax		
		inc si
        loop output_antiperiod
close_ap:
		display closedbracket
		display openbracket
	    mov cx,plen	
		cmp cx,0
		je close_p		
output_period:
        mov al,seqbits[si]
		call near ptr display_ax
		inc si
        loop output_period
close_p:		
		display closedbracket
		
		display crlf
		
exit: 
        MOV AH,4CH              ; ritorno al DOS
        INT 21H

main endp




; routine di conversione di un numero a 16 bit (il cui valore e' posto nello stack)
; nell'equivalente in una base prefissata, espresso in ASCII e posto
; in una stringa di N caratteri, il cui indirizzo e' anch'esso inserito nello stack
; prima della chiamata. Il valore di ritorno N rimpiazza il valore immesso nello stack
; dal chiamante, che indica la base in cui convertire il numero
bin2bascii proc near
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        pushf

        mov bp,sp
        add bp,16                          ; rimuove l'effetto dei push qui sopra
        mov ax,SS:[bp+6]                   ; numero da convertire (e' sepolto sotto 3 words)

        mov bx,[bp+2]
        mov cx,0
        mov dx,0
again:  div bx                             ; in DX il resto, in AX il quoziente di [DX:AX]/[BX]
        ;or dx,0030h                       ; si rende ASCII il contenuto di dx
        mov si,dx
        mov dl,alfabeto_numerazione[si]    ; si prende il simbolo di numerazione dall'array apposito
        xor dh,dh
        push dx
        inc cx
        cmp ax,0
        je save_result
        xor dx,dx
        jmp again
save_result:
        mov di,0
        mov bx,[bp+4]                      ; offset della stringa destinazione
cycle:  pop dx
        mov [bx][di],dl
        inc di
        loop cycle
        mov [bp+2],di                      ; numero di caratteri nella stringa destinazione

        popf
        pop bp
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax

        ret

bin2bascii endp


display_ax proc near 
        push ax
        push bx

        push ax
        mov ax,offset stringa_ax
        push ax
        mov ax,10
        push ax
        call near ptr bin2bascii
        pop bx                       ; in bx il numero di caratteri della stringa
        add sp,4                                     

        mov stringa_ax[bx],' '       ; spazio di formattazione
        mov stringa_ax[bx+1],'$'     ; $ per poter stampare
        display stringa_ax

        pop bx
        pop ax
        ret

display_ax endp



cseg ends

END MAIN                     ; il programma comincia all'indirizzo di MAIN






   

                      
